package com.example.nto.utils;


import com.example.nto.dto.EmployeeDto;
import com.example.nto.dto.RegisterDto;
import com.example.nto.entity.Employee;
import lombok.experimental.UtilityClass;

@UtilityClass
public class EmployeeMapper {

    public EmployeeDto convertToDto(Employee employee) {
        EmployeeDto employeeDto = new EmployeeDto();
        employeeDto.setId(employee.getId());
        employeeDto.setName(employee.getName());
        employeeDto.setLogin(employee.getLogin());
        employeeDto.setAvatarUrl(employee.getAvatarUrl());
        employeeDto.setPosition(employee.getPosition());
        employeeDto.setLastVisit(employee.getLastVisit());
        employeeDto.setAuthorities(employee.getAuthorities().iterator().next().getAuthority());

        return employeeDto;

    }

    public Employee convertFromDto(EmployeeDto employeeDto) {
        Employee employee = new Employee();
        employee.setId(employeeDto.getId());
        employee.setName(employeeDto.getName());
        employee.setLogin(employeeDto.getLogin());
        employee.setAvatarUrl(employeeDto.getAvatarUrl());
        employee.setPosition(employeeDto.getPosition());
        employee.setLastVisit(employeeDto.getLastVisit());

        return employee;

    }

    public Employee convertFromRegisterDTO(RegisterDto registerDto) {
        Employee employee = new Employee();
        employee.setName(registerDto.getName());
        employee.setLogin(registerDto.getLogin());
        return employee;
    }


    public RegisterDto convertToRegisterDTO(Employee employee) {
        RegisterDto registerDto = new RegisterDto();
        registerDto.setName(employee.getName());
        registerDto.setLogin(employee.getLogin());
        return registerDto;
    }
}
